'****************************************************************************************
'**** Script de configuration automatique de la signature Outlook.
'**** Date : 04/11/2009
'**** Test avec : Outlook 2003, Serveur Windows Server 2003 et Exchange 2007.
'**** Auteur : Alexandre FONTON, www.nalex.fr
'**** Modifi par Martial AUROY le 10/08/2011
'****************************************************************************************


'##########################################################
'#### Lignes de configuration :


' Indiquer le nom de la signature utilis dans Outlook et pour nommer les fichiers htm, rtf et txt
NOM_SIGNATURE = "SIGNATURE_001"

' Indiquer le rpertoire source contenant le modle de la signature (gnralement un emplacement rseau).
REP_MODELE_SIGNATURE = "\\monserveur\...\SignatureOutlook"

'Lister les fichiers images necessaires pour la signature HTML.
TAB_FICHIERS_IMAGES = array("", "")

'Liste des variables  rsoudre via l'annuaire Active Directory
'   Colonne 1 : Nom des variables prsentes dans les fichiers htm, rtf et txt.
'   Colonne 2 : Nom du champ Active Directory  utiliser  la place de la variable.
'   Colonne 3 : Nom du champ Active Directory  utiliser si le prcdent champ n'est pas renseign dans le compte utilisateur.
'   Colonne 4 : Texte  afficher si aucun des deux champ Active Directory n'est renseign.
TAB_VARIABLES =  array( array("#NOMAFFICHE#", "displayName"  , "", "none"), _
						array("#DEPARTMENT#"  , "department" , "", "none"), _
						array("#TEL#"     , "telephoneNumber", "", "none"), _
						array("#MOBILE#"     , "mobile", "telephoneNumber", "none") _
					  )

					  
'##########################################################
'#### lancement du traitement.		  
If Not IsOutlookRunning Then
    '*** Copie et personalisation des fichiers de signature dans "%USERPROFILE%\Application Data\Microsoft\Signatures".
        Call getLdapProfileAndCopyFiles(REP_MODELE_SIGNATURE, NOM_SIGNATURE, TAB_FICHIERS_IMAGES, TAB_VARIABLES)
    '*** Dfinition de la nouvelle signature par dfaut dans Outlook.
        Call SetDefaultSignature(NOM_SIGNATURE)
'else
'        strMsg = "Veuillez fermer Outlook avant d'executer ce script"
'        MsgBox strMsg, vbExclamation, "SetDefaultSignature"
End If


'##########################################################
'#### Fonctions VBS.
' /**
' * Fonction GetOsName()
' *  renvoi la chaine de la version de windows
' * @author : M. AUROY
' * @date : 10/08/2010
function GetOsName() 
' recherche de la version de l'OS
wscript.echo "recherche la version de l'OS"
strComputer = "."
strResultat=""
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colOperatingSystems = objWMIService.ExecQuery _
    ("Select * from Win32_OperatingSystem")
For Each objOperatingSystem in colOperatingSystems
    strResultat=strResultat &  objOperatingSystem.Caption
Next
dim start 
dim length
strResultat = ucase(strResultat)
if InStr(1,strResultat,"7") >0 then GetOsName="SEVEN"
if InStr(1,strResultat,"VISTA") >0 then GetOsName="VISTA"
if InStr(1,strResultat,"XP") >0 then GetOsName="XP"
'msgbox(strResultat)
end function
' --------------

' /**
' * Fonction GetOutlookVersion()
' *  renvoi la version d'outlook si outlook existe
' * @author : M. AUROY
' * @date : 10/08/2010
function GetOutlookVersion()
    GetOutlookVersion=""
    Dim strOutlookPath
    wscript.echo "recherche la version d'Outlook"
    strOutlookPath = FindFile("C:\","outlook.exe")
    'msgbox("strOutlookPath " & strOutlookPath)
    if strOutlookPath <>"" then 
       Set System = CreateObject("Scripting.FileSystemObject")
       GetOutlookVersion = System.GetFileVersion(strOutlookPath)
    end if
 
 end function
' --------------

' /**
' * Fonction FindFile()
' * renvoi le chemin du fichier recherch ("chemin  partir de", "nom du fichier avec extension")
' * @author : M. AUROY
' * @date : 10/08/2010
function FindFile(strFolder,strFile)
    On ERROR Resume Next
    FindFile = ""
    Dim File
    Dim Folder
    Set System = CreateObject("Scripting.FileSystemObject")

    For Each Folder In System.GetFolder(strFolder).SubFolders
        ' si non system
        if (  ((Folder.attributes And 4) <> 4)   )then 
            For Each File In Folder.Files
                If LCase(File.Name) = LCase(strFile) Then
                    FindFile = File
                exit function
                End If
            Next 'File
        end if
        FindFile = FindFile(Folder,strFile)
        if FindFile <>"" then exit function
    Next 'Folder
END function
' --------------

' /**
' * Fonction getLdapProfileAndCopyFiles()
' *  Copie des fichiers de ressources graphiques du rpertoire rseau
' * @param string strSigName Nom de la signature Outlook
' * @param string signatureName Nom de la signature (prsent dans la liste des signature Outlook et utilise pour nommer les fichiers de signature).
' * @param array tFichiersImages Tableau 1D contenant les noms des fichiers images necessaires pour la signature HTML (ne pas indiquer de rpertoire)
' * @param array tVariables Tableau 2D contenant la liste des variables  remplacer par une valeur issue de AD.
' * Algo :
' *  1- Vrifie que Outlook est ferm.
' *  2- Utilisation de WMI pour accder en criture  la base de registre.
' *  3- Rcupre le nom des profils Outlook utiliss.
' *  4- Affectation du nom de signature  tous les profils
'**/
Sub getLdapProfileAndCopyFiles(baseRepSrc, signatureName, tFichiersImages, tVariables)
  Dim htlmFile, htmlFileDest
  Set dtmConvertedDate = CreateObject("WbemScripting.SWbemDateTime")
  Set WshShell = WScript.CreateObject("WScript.Shell")
  repProfil = WshShell.ExpandEnvironmentStrings("%USERPROFILE%")

'msgbox("version outlook " & CStr(int(left(GetOutlookVersion(),2))))

Select case GetOsName()
    case "XP":
        repSignatures = repProfil & "\Application Data\Microsoft\Signatures"
    case "SEVEN", "VISTA":
        repSignatures = repProfil & "\AppData\Roaming\Microsoft\Signatures"
    case else:
        'msgbox("l'OS n'est pas rpertori dans ce programme, contactez le service technique. Merci.")
    exit sub
End Select
wscript.echo "Le repertoire des signatures est " & repSignatures

  '*** Cration du rpertoire Signature, si aucune signature n'a t cr par le pass.
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  if  objFSO.FolderExists(repSignatures) = False then
        wscript.echo "Cration du rpertoire " & repSignatures
		objFSO.CreateFolder (repSignatures)
  End if
 

  '*** Copie le rpertoire neccessaire pour la signature.
  Dim RepSource
  Dim RepCible
  RepSource = baseRepSrc & "\" &  signatureName & "_Fichiers" 
  RepCible = repSignatures & "\" &  signatureName & "_Fichiers"

  '*** Cration du sous rpertoire contenant les fichier lis  la signature
  if  objFSO.FolderExists(RepCible) = False then
        wscript.echo "Cration du sous rpertoire " & RepCible & " contenant les fichier lis  la signature"
		objFSO.CreateFolder (RepCible)
  End if
  wscript.echo "Copie le rpertoire " & RepSource & "neccessaire pour la signature dans " & RepCible & " ..."
  call objFSO.CopyFolder (RepSource, RepCible ,TRUE)
 
'   '*** Copie le rpertoire neccessaire pour la signature.
'  For Each image In tFichiersImages
'		Call objFSO.CopyFile(baseRepSrc & "\" & image, repSignatures & "\" & image)
'  Next

  '*** Prparation des noms de fichiers de signatures gnriques  copier
  htlmFile = 	 baseRepSrc & "\" & signatureName & ".htm"
  htmlFileDest = repSignatures & "\" & signatureName & ".htm"
  rtfFile = 	 baseRepSrc & "\" & signatureName & ".rtf"
  rtfFileDest =  repSignatures & "\" & signatureName & ".rtf"
  txtFile =		 baseRepSrc & "\" & signatureName & ".txt"
  txtFileDest =  repSignatures & "\" & signatureName & ".txt"

  '*** Copie des fichiers de signatures gnriques
  strUserInfo = getStrUserInfo()
  result = replaceLdapUserInfoInFile(strUserInfo, htlmFile, htmlFileDest, tVariables)
  result = replaceLdapUserInfoInFile(strUserInfo, rtfFile, rtfFileDest, tVariables)
  result = replaceLdapUserInfoInFile(strUserInfo, txtFile, txtFileDest, tVariables)

  Set objFSO = Nothing

End Sub





' /**
' * Fonction SetDefaultSignature()
' *  Activation de la signature Outlook nomme dans la variable strSigName.
' * @param string strSigName Nom de la signature Outlook
' * @author : A. FONTON
' * @date : 26/09/2008
' * Algo :
' *  1- Vrifie que Outlook est ferm.
' *  2- Utilisation de WMI pour accder en criture  la base de registre.
' *  3- Rcupre le nom des profils Outlook utiliss.
' *  4- Affectation du nom de signature  tous les profils
'**/
Sub SetDefaultSignature(strSigName)
    Const HKEY_CURRENT_USER = &H80000001
    strComputer = "."

    '--- If outlook is closed
    If Not IsOutlookRunning Then
        ' Acces WMI au registre.
        Set objreg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")
        ' Emplacement parent dans le registre  utiliser.
        strKeyPath = "Software\Microsoft\Windows NT\CurrentVersion\Windows Messaging Subsystem\Profiles\"

        ' Nom du profil Outlook par dfaut.
        objreg.GetStringValue HKEY_CURRENT_USER, strKeyPath, "DefaultProfile", strProfile

        ' Converti le nom du profile en tableau de "Byte".
        myArray = StringToByteArray(strSigName, True)
        '
        strKeyPath = strKeyPath & strProfile & "\9375CFF0413111d3B88A00104B2A6676"
        objreg.EnumKey HKEY_CURRENT_USER, strKeyPath, arrProfileKeys
        
        For Each subkey In arrProfileKeys
            strsubkeypath = strKeyPath & "\" & subkey
            'On Error Resume Next
            objreg.SetBinaryValue HKEY_CURRENT_USER, strsubkeypath, "New Signature", myArray
            objreg.SetBinaryValue HKEY_CURRENT_USER, strsubkeypath, "Reply-Forward Signature", myArray
            'MsgBox  strsubkeypath
        Next
    Else
        strMsg = "Please shut down Outlook before running this script."
        'MsgBox strMsg, vbExclamation, "SetDefaultSignature"
    End If
End Sub


' /**
' *  Activation de la signature Outlook nomme dans la variable strSigName.
' * @param string strSigName Nom de la signature Outlook
'**/
Function IsOutlookRunning()
    strComputer = "."
    strQuery = "Select * from Win32_Process " & _
               "Where Name = 'Outlook.exe'"
    Set objWMIService = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate}!\\" _
        & strComputer & "\root\cimv2")
    Set colProcesses = objWMIService.ExecQuery(strQuery)
    For Each objProcess In colProcesses
        If UCase(objProcess.Name) = "OUTLOOK.EXE" Then
            IsOutlookRunning = True
        Else
            IsOutlookRunning = False
        End If
    Next
End Function

Public Function StringToByteArray _
                 (Data, NeedNullTerminator)
    Dim strAll
    strAll = StringToHex4(Data)
    If NeedNullTerminator Then
        strAll = strAll & "0000"
    End If
    intLen = Len(strAll) \ 2
    ReDim arr(intLen - 1)
    For i = 1 To Len(strAll) \ 2
        arr(i - 1) = CByte _
                   ("&H" & Mid(strAll, (2 * i) - 1, 2))
    Next
    StringToByteArray = arr
End Function

Public Function StringToHex4(Data)
    ' Input: normal text
    ' Output: four-character string for each character,
    '         e.g. "3204" for lower-case Russian B,
    '        "6500" for ASCII e
    ' Output: correct characters
    ' needs to reverse order of bytes from 0432
    Dim strAll
    For i = 1 To Len(Data)
        ' get the four-character hex for each character
        strChar = Mid(Data, i, 1)
        strTemp = Right("00" & Hex(AscW(strChar)), 4)
        strAll = strAll & Right(strTemp, 2) & Left(strTemp, 2)
    Next
    StringToHex4 = strAll
End Function







'***********************************************************************************
'**** Fonction : getStrUserInfo                         ****
'**** Rle : Renvois une chane contenant les informations sur l'utilisateur    ****
'**** Recois : Rien                                                             ****
'**** Renvois : une chane de caractres.                                       ****
'**** Exemple : "CN=Alexandre Fonton,OU=Informatique,OU=Service-Technique,      ****
'****                   OU=Users,OU=Vulcania,DC=semvolcans,DC=com"          ****
'************************************************************************************
Function getStrUserInfo()
   Dim ADSysInfo  '// Objet contenant les informations rseau de l'utilisateur.
        '----- obtient les paramtres de d'utilisateur ------
        Set ADSysInfo = CreateObject("ADSystemInfo")
        getStrUserInfo = ADSysInfo.UserName
End Function





'***********************************************************************************
'**** Fonction : replaceLdapUserInfoInFile                                   
'**** Rle : Intgre les informations LDAP dans le fichier.                     
'**** @param userLdapInfo Objet LDAP.                                           
'**** @param file Nom du fichier source  modifier.                                    
'**** @param String fileDest Chemin et nom du fichier de destination
'**** @param Array tVariables  Tableau 2D contenant la liste des variables  remplacer par une valeur issue de AD
'**** Renvois : une chane de caractres.                                       
'************************************************************************************
Function replaceLdapUserInfoInFile(strUserInfo, fileModele, fileDest, tVariables)
    Dim userLdapInfo
    Dim objFSO, objFile
    Const ForReading = 1
    Const ForWriting = 2

    
	Set userLdapInfo = GetObject("LDAP://" & strUserInfo)
    '--- Lecture des champs de la fiche LDAP de l'utilisateur courant.
    '--- La gestion d'erreur permet de grer les cas ou un champ n'est pas renseign dans AD.
  
	'*** Rsolution des variables via l'annuaire Active Directory.

	For i = 0 To UBound(tVariables)
		On Error Resume Next
		Err.Number = 0
			tVariables(i)(3) = userLdapInfo.Get(tVariables(i)(1))
			' Si ce paramtre AD  est introuvable, on prend la valeur par dfaut.
			If (Err.Number <> 0) Then
				tVariables(i)(3) = userLdapInfo.Get(tVariables(i)(2))
			End If
		On Error GoTo 0 ' Invalide la gestion d'erreur
	Next

	'--- Boucle de debug.
'	For Each variable In tVariables 
'		MsgBox	variable(0) & " : " & variable(1)  & " : " & variable(3)
'	Next


	'*** Lecture du fichier modle et copie de son contenu dans la variable strText.
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objFile = objFSO.OpenTextFile(fileModele, ForReading)
	strText = objFile.ReadAll
	objFile.Close

	
	'*** Substitution des variables du type #DONNEE# par leurs valeurs issus de l'objet LDAP utilisateur.
	For Each variable In tVariables 
			strText = Replace( strText, variable(0), variable(3))
			'MsgBox	variable(0) & " <=> " & variable(3)
	Next

	'*** Suppression du fichier de signature si il existait dj.
	If objFSO.FileExists(fileDest) = True Then
		objFSO.DeleteFile(fileDest)
	End If

	'*** Cration du fichier de signature.
	Set objFile = objFSO.CreateTextFile(fileDest, False)

	'*** Ecriture du contenu du fichier de signature personnalis.
    objFile.WriteLine strText
	objFile.Close
	Set objFSO = Nothing
	
End Function

